import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World {
    int l = 0;
    
    Integer answer = null;
    String equation = null;
    Integer pAnswer = null;
    
    int score = 0;
    final int totTime = 3600;
    int time = totTime;
    
    String cKey = "";
    String lastKey = "";
    boolean keyPressed = false;
    
    Color background = Color.gray;
    
    public Worldy() {
        super(1000, 500, 1);
        setup(0);
    }
    
    public void act() {
        keyEvents();
        if(l == 0) {
            if(Greenfoot.mouseClicked(this)) setup(1);
        } else if(l == 1) {
            getBackground().setColor(background);
            getBackground().fill();
            if(time == 0) {
                setup(2);
                return;
            }
            type();
            if(answer==null || (pAnswer!=null && "enter".equalsIgnoreCase(Greenfoot.getKey()))) {
                if(answer!=null) {
                    if(pAnswer==answer) score+=2;
                    else score--;
                    pAnswer = null;
                }
                answer = Greenfoot.getRandomNumber(101);
                equation = getEquation(answer);
            }
            if(pAnswer == null) drawNum(equation+"\n", 200);
            else drawNum(equation + "\n" + pAnswer, 200);
            getBackground().setColor(Color.white);
            
            GreenfootImage string = new GreenfootImage(String.valueOf(score), 40,
                Color.white, new Color(0, 0, 0, 0));
            getBackground().drawImage(string, getWidth()/2-string.getWidth()/2, 0);
            
            getBackground().fillRect(0, getHeight()-20, getWidth()*time/totTime, 20);
            time--;
        }
    }
    
    public void keyEvents() {
        if(cKey.equals("")) {
            if(Greenfoot.isKeyDown("1")) cKey = "1";
            else if(Greenfoot.isKeyDown("2")) cKey = "2";
            else if(Greenfoot.isKeyDown("3")) cKey = "3";
            else if(Greenfoot.isKeyDown("4")) cKey = "4";
            else if(Greenfoot.isKeyDown("5")) cKey = "5";
            else if(Greenfoot.isKeyDown("6")) cKey = "6";
            else if(Greenfoot.isKeyDown("7")) cKey = "7";
            else if(Greenfoot.isKeyDown("8")) cKey = "8";
            else if(Greenfoot.isKeyDown("9")) cKey = "9";
            else if(Greenfoot.isKeyDown("0")) cKey = "0";
            else if(Greenfoot.isKeyDown("backspace")) cKey = "backspace";
            keyPressed = false;
        } else {
            if(!Greenfoot.isKeyDown(cKey)) {
                lastKey = cKey;
                keyPressed = true;
                cKey = "";
            }
        }
    }
    
    public String getKey() {
        if(keyPressed) return lastKey;
        else return "";
    }
    
    public void type() {
        if(pAnswer!=null) {
            String a = String.valueOf(pAnswer);
            if("1234567890".contains(getKey()) && a.length() < 9) a += getKey();
            else if("backspace".equals(getKey())) a = a.substring(0, a.length()-1);
            if(!a.equals("")) pAnswer = Integer.valueOf(a);
            else pAnswer = null;
        } else {
            if(!getKey().equals("") && "1234567890".contains(getKey())) pAnswer = Integer.valueOf(getKey());
        }
    }
    
    public void setup(int l) {
        getBackground().setColor(background);
        getBackground().fill();
        if(l == 0) {
            GreenfootImage string = new GreenfootImage("Are you ready?\n[click anywhere to start]", 75,
                Color.white, new Color(0, 0, 0, 0));
            getBackground().drawImage(string, getWidth()/2-string.getWidth()/2,
                getHeight()/2-string.getHeight()/2);
        } else if(l == 1) {
            int delay = 60;
            drawNum("3", 500);
            Greenfoot.delay(delay);
            getBackground().setColor(background);
            getBackground().fill();
            drawNum("2", 500);
            Greenfoot.delay(delay);
            getBackground().setColor(background);
            getBackground().fill();
            drawNum("1", 500);
            Greenfoot.delay(delay);
        } else {
            UserInfo me = UserInfo.getMyInfo();
            if(me.isStorageAvailable() && score > me.getScore()) {
                me.setScore(score);
                me.store();
            }
            addObject(new ScoreBoard(getWidth(), getHeight()), getWidth()/2, getHeight()/2);
        }
        this.l = l;
    }
    
    public String getEquation(int answer) {
        String e = "";
        int randD = Greenfoot.getRandomNumber(4);
        if(randD == 0) {
            int randN = Greenfoot.getRandomNumber(101);
            if(answer < randN) e = "" + randN + " - " + Math.abs(answer-randN) + " =";
            else e = "" + (answer-randN) + " + " + randN + " =";
        } else if(randD == 1) {
            int randN = Greenfoot.getRandomNumber(9)+2;
            if(randN!=0 && answer%randN == 0) e = "" + randN + " x " + answer/randN + " =";
            else e = "" + answer*randN + " ÷ " + randN + " =";
        } else if(randD == 2) {
            if(Math.cbrt(answer)%1 == 0) e = "" + (int)Math.cbrt(answer) + "^3";
            else {
                this.answer = Greenfoot.getRandomNumber(10)+1;
                answer = this.answer;
                e = "^3√" + (int)Math.pow(answer, 3);
            }
        } else if(randD == 3) {
            if(Math.sqrt(answer)%1 == 0) e = "" + (int)Math.sqrt(answer) + "^2";
            else {
                this.answer = Greenfoot.getRandomNumber(10)+1;
                answer = this.answer;
                e = "^2√" + (int)Math.pow(answer, 2);
            }
        }
        System.out.println(answer);
        return e;
    }
    
    public void drawNum(String num, int size) {
        GreenfootImage string = new GreenfootImage(num, size,
            Color.white, new Color(0, 0, 0, 0));
        getBackground().drawImage(string, getWidth()/2-string.getWidth()/2,
            getHeight()/2-string.getHeight()/2);
    }
}
